#include "email-core-mail.h"
#include "email-internal-types.h"
#include "email-types.h"
#include "email-debug-log.h"
#include "email-core-dpm.h"

static int g_dpm_policy_status = 0;


#include <dpm/restriction.h>


void on_restriction(const char* policy, const char* value, void* user_data)
{
	int is_allowed = strcmp(value, "allowed") == 0 ? 1 : 0;
	/* true = 1;
	   false = 0; */

	EM_DEBUG_LOG("dpm_cb_status : %d",  is_allowed);
	g_dpm_policy_status = is_allowed;
}

static int callback_id;
static device_policy_manager_h dpm;

void emcore_dpm_instance_create()
{


	#ifdef TIZEN_FEATURE_EMAIL_DPM

	EM_DEBUG_LOG("dpm_instance_create");
	dpm = dpm_manager_create();
	int allowed;
	void *user_data = NULL;
	int ret = dpm_restriction_get_popimap_email_state(dpm, &allowed);
	if (ret != DPM_ERROR_NONE) {
		EM_DEBUG_LOG("dpm_error : %d", ret);
		//TODO add error routin
	}

		EM_DEBUG_LOG("dpm_policy  : %d", allowed);
	if (allowed == false) {

		/* OPERATION IS RESTRICTED */
		g_dpm_policy_status = false;

	} else if (allowed == true) {

		/* OPERATION IS ALLOWED */
		g_dpm_policy_status = true;

	} else {
		EM_DEBUG_LOG("dpm wrong status : %d", allowed);

		//TODO add error routin
	}

	// Callback will be called when policy is changed
	if (dpm_add_policy_changed_cb(dpm , "popimap_email", on_restriction, user_data, &callback_id) != 0)
		EM_DEBUG_LOG("dpm_add_policy_changed_cb failed /n");

	#else

	EM_DEBUG_LOG("dpm_off");

	#endif /* TIZEN_FEATURE_EMAIL_DPM */

}
int emcore_get_dpm_status()
{

	EM_DEBUG_LOG("get_dpm_status()");
	#ifdef TIZEN_FEATURE_EMAIL_DPM
		return g_dpm_policy_status;
	#else
		return true;
	#endif /* TIZEN_FEATURE_EMAIL_DPM */

}

void dpm_interface_destroy()
{
	dpm_remove_policy_changed_cb(dpm, callback_id);
	dpm_manager_destroy(dpm);
}

